| Home | Libraries | People | FAQ | More

## Struct template make_unsigned_or_unbounded

boost::random::traits::make_unsigned_or_unbounded — Converts the argument type T to either an unsigned type or an unbounded integer type.

## Synopsis

    // In header: <boost/random/traits.hpp>

    template<typename T>
    struct make_unsigned_or_unbounded {
    };

## Description

This trait has a single member `type` which is either the unsigned type corresponding to T or an unbounded integer type. This trait is used to generate types suitable for the calculation of a range: as a result if T is signed, then member `type` should define a type with one more bit precision than T. For built-in types this trait defaults to `boost::make_unsigned<T>::type`. For user defined types it simply asserts that the argument type T is either an unbounded integer, or an unsigned one (using std::numeric_limits). User defined specializations may be provided for other cases.